package net.sf.sql2java.generator.events;

import java.util.Map;

import net.sf.sql2java.common.parameters.StringParser;
import net.sf.sql2java.common.parameters.handlers.ContextParameterHandler;

import org.apache.velocity.app.event.ReferenceInsertionEventHandler;

public class ParameterStringReference implements ReferenceInsertionEventHandler {
	private StringParser parser;
	
// -- Constructors ------------------------------------------------------------
	
	public ParameterStringReference(Map<String, ?> context) {
		this.parser = new StringParser(new ContextParameterHandler(context));
	}
	
// -- Implementations ---------------------------------------------------------

	@Override
	public Object referenceInsert(String reference, Object value) {
		// -- return the value if it isn't a string
		if (! (value instanceof String)) return value;
		
		// -- convert the value to a String
		String result = value.toString();
		
		// -- parse the string
		result = parser.parse(result);
		
		// -- return the result
		return result;
	}

}
