package net.sf.sql2java.generator.writer;

import java.util.HashSet;
import java.util.Properties;
import java.util.Set;

import net.sf.sql2java.generator.writer.merge.Conflict;

public abstract class CodeWriter {
	private Properties properties;
	private Set<Conflict> conflicts;

// -- Constructors ------------------------------------------------------------
	
	protected CodeWriter() {
		conflicts = new HashSet<Conflict>();
	}
	
// -- To Implement ------------------------------------------------------------
    
    public abstract void write(String path, String content) throws Exception;
    
// -- Conflict Handlers -------------------------------------------------------
    
    public void addConflict(Conflict conflict) {
    	conflicts.add(conflict);
    }
    
    public void removeConflict(Conflict conflict) {
    	conflicts.remove(conflict);
    }
    
// -- Proprerty Handlers ------------------------------------------------------
	
	public void setProperty(String name, String value) {
		properties.setProperty(name, value);
	}
	
	public String getProperty(String name) {
		return properties.getProperty(name);
	}
	
	public String getProperty(String name, String defaultValue) {
		return properties.getProperty(name, defaultValue);
	}
	
// -- Getters -----------------------------------------------------------------
	
	public Set<Conflict> getConflicts() {
		return conflicts;
	}
	
// -- Setters -----------------------------------------------------------------
	
	public void setProperties(Properties properties) {
		this.properties = properties;
	}
    
}
